freeslot("SPR2_DRIL", 
	"S_PLAY_DRILL", 	
	"MT_INSTASHIELD",
	"S_INSTASHIELD",
	"SPR_TWSP")

states[S_PLAY_DRILL] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE|SPR2_DRIL,
	tics = -1,
	var1 = 3,
	var2 = 1,
	nextstate = S_PLAY_DRILL
}

mobjinfo[MT_INSTASHIELD] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INSTASHIELD,
	radius = 0,
	height = 0,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

states[S_INSTASHIELD] = {
	sprite = SPR_TWSP,
	frame = A|FF_ANIMATE,
	tics = 11,
	var1 = 10,
	var2 = 1,
	nextstate = S_NULL
}

-- Sonic
addHook("JumpSpinSpecial", function(player)
local mo = player.mo
	if player.doublejumped == nil
		player.doublejumped = false
	end
	if player and player.mo and player.mo.valid and player.mo.skin == "sonic" and not player.doublejumped and not player.homing and not (player.playerstate == PST_DEAD) and not player.paintimer
		S_StartSound(player.mo, sfx_jump)
		player.mo.state = S_PLAY_SPRING
		player.pflags = $|PF_NOJUMPDAMAGE
		local doublejumpspeed = 12*FRACUNIT
		local doublejumpobject = MT_SPINDUST
		local thrustspeed = 1*FRACUNIT
		if player.powers[pw_super]
			doublejumpspeed = $*2
			thrustspeed = $*2
		end
		for i = 1, 16 -- Spawn 16 to create a full circle 
			local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, doublejumpobject)
			P_InstaThrust(dust, i*ANGLE_22h, (20*FRACUNIT)*1)
			P_SetObjectMomZ(dust, (player.mo.momz/2)*-1, false)
		end
		P_SetObjectMomZ(player.mo, doublejumpspeed)
		P_Thrust(player.mo,player.mo.angle,(player.speed/8)+thrustspeed)
		player.doublejumped = true
	end
end)

addHook("PlayerThink", function(player)
	if player and player.mo and player.mo.valid and player.mo.skin == "sonic"
		if (P_IsObjectOnGround(player.mo) and not (player.cmd.buttons & BT_USE)) or player.powers[pw_justsprung] or player.powers[pw_carry] or P_PlayerInPain(player) or (player.playerstate == PST_DEAD)
			player.doublejumped = false
		end
		if player.doublejumped == true
			if player.mo.state == S_PLAY_FALL
				player.mo.state = S_PLAY_JUMP
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
			end
		end
	end
end)

local function jumprefresh (target, inflictor)
	if not inflictor or not inflictor.valid
	or not inflictor.player or not inflictor.player.valid then
		return
	end
	if inflictor.player.mo.skin == "sonic" then
		inflictor.player.doublejumped = false
	end
end

addHook("MobjDamage", jumprefresh)
addHook("MobjDeath", jumprefresh)
--

-- Tails
addHook("PlayerThink", function(player)
	if player and player.mo and player.mo.valid and player.mo.skin == "tails"	
		if player.bot
			return
		end
		if player.bombtimer == nil
			player.bombtimer = 0
		end
		if player.bombtimer > 0
			player.bombtimer = $-1
		end
		if player.bomb and player.bomb.valid
			if player.bomb.state == S_FBOMB1 or player.bomb.state == S_FBOMB2
				player.bomb.state = S_THROWNGRENADE1
			end
		end
		if (player.cmd.buttons & BT_CUSTOM1) or (player.cmd.buttons & BT_ATTACK)
			if player.bombtimer == 0
				player.bombtimer = TICRATE
				player.bomb = P_SPMAngle(player.mo, MT_FBOMB, player.mo.angle, 1)
				if player.bomb and player.bomb.valid
					player.bomb.state = S_THROWNGRENADE1
				end
			end
		end
		if player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLY_TIRED
			if (player.cmd.buttons & BT_USE)
				S_StartSound(player.mo, sfx_spin)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
			end
		end
	end
end)

local function flyrefresh (target, inflictor)
	if not inflictor or not inflictor.valid
	or not inflictor.player or not inflictor.player.valid then
		return
	end
	if inflictor.player.mo.skin == "tails" then
		inflictor.player.pflags = $1 & ~PF_THOKKED
	end
end

addHook("MobjDamage", flyrefresh)
addHook("MobjDeath", flyrefresh)

-- Knuckles
addHook("PlayerCanDamage", function(player) -- Player kills enemies while sliding
	if player and player.valid and (player.mo.skin == "knuckles")
		if player.mo.state == S_PLAY_DRILL then
			return true
		end
	end
end)

addHook("PlayerThink", function(player)
	if player and player.mo and player.mo.valid and player.mo.skin == "knuckles"
		if player.drilltime == nil
			player.drilltime = 0
			player.instatime = 0
			player.usetimer = 0
		end
		if player.instatime > 0
			player.instatime = $-1
		end
		if player.mo.tracer and player.mo.tracer == MT_INSTASHIELD
			if player.mo.state != S_PLAY_JUMP
				P_RemoveMobj(player.mo.tracer)
			end
		end
		if (player.cmd.buttons & BT_USE)
			if not player.usetimer
				if player.mo.state == S_PLAY_GLIDE
					S_StartSound(player.mo, sfx_zoom)
					player.mo.state = S_PLAY_DRILL
				end
				if not P_IsObjectOnGround(player.mo) and not player.instatime
				and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_DRILL)
					player.instatime = TICRATE/2
					S_StartSound(player.mo, sfx_s3k42)
					local instashield = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_INSTASHIELD)
					instashield.target = player.mo
					instashield.spritexscale = $
					instashield.spriteyscale = $
					player.mo.tracer = instashield
				end
				if P_IsObjectOnGround(player.mo)
					player.instatime = 0
				end
			end
			player.usetimer = $+1
		else
			player.usetimer = 0
		end
		if player.mo.state == S_PLAY_DRILL
			player.mo.momz = (-25*FRACUNIT+(player.drilltime*-1)*FRACUNIT)*P_MobjFlip(player.mo)
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = TICRATE/4
			player.pflags = $1 & ~PF_NOJUMPDAMAGE
			player.pflags = $1 & ~PF_THOKKED
			player.pflags = $1 & ~PF_GLIDING
			player.drilltime = $+1
		else
			player.drilltime = 0
		end
		if P_IsObjectOnGround(player.mo)
			if player.drilltime > TICRATE/2
				P_NukeEnemies(player.mo, player.mo, player.drilltime*FRACUNIT)
				S_StartSound(player.mo, sfx_pstop)
				player.pflags = $1 & ~PF_GLIDING
				player.mo.state = S_PLAY_WALK
				player.drilltime = 0
			end
			if player.drilltime > 0
				if player.mo.state == S_PLAY_DRILL
					S_StartSound(player.mo, sfx_pstop)
				end
				player.pflags = $1 & ~PF_GLIDING
				player.mo.state = S_PLAY_WALK
				player.drilltime = 0
			end
			player.drilltime = 0
		end
	end
end)

addHook("ShouldDamage", function(knuckles, inflictor, source, damage, element)
	if (knuckles.tracer) and knuckles.tracer.type == MT_INSTASHIELD
		if not (element & DMG_DEATHMASK)
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		A_CapeChase(mo)
	end
end, MT_INSTASHIELD)

local function fallrefresh (target, inflictor)
	if not inflictor or not inflictor.valid
	or not inflictor.player or not inflictor.player.valid then
		return
	end
	if inflictor.skin == "knuckles" and inflictor.state == S_PLAY_DRILL then
		inflictor.player.pflags = $1 & ~PF_THOKKED|PF_GLIDING
		inflictor.state = S_PLAY_GLIDE
	end
end

addHook("MobjDamage", fallrefresh)
addHook("MobjDeath", fallrefresh)

-- Amy
addHook("PlayerThink", function(player)
	if player and player.mo and player.mo.valid and player.mo.skin == "amy"
		if player.twinspining == nil
			player.twinspining = false
		end
		if not P_IsObjectOnGround(player.mo) and (player.cmd.buttons & BT_USE)
			if player.mo.momz < (-4*FRACUNIT)*P_MobjFlip(player.mo)
				player.mo.momz = $+(2*FRACUNIT)*P_MobjFlip(player.mo)
			end
		end
		if player.mo.state == S_PLAY_TWINSPIN
			player.twinspining = true
		else
			if P_IsObjectOnGround(player.mo) and player.twinspining == true
				player.mo.state = S_PLAY_JUMP
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
				P_SetObjectMomZ(player.mo, 25*FRACUNIT)
				S_StartSound(player.mo, sfx_sprong)
			end
			player.twinspining = false
		end
	end
end)

-- Fang
addHook("PlayerThink", function(player)
	if player and player.mo and player.mo.valid and player.mo.skin == "fang"	
		if player.bombtimer == nil
			player.bombtimer = 0
		end
		if player.bombtimer > 0
			player.bombtimer = $-1
		end
		if (player.cmd.buttons & BT_CUSTOM1) or (player.cmd.buttons & BT_ATTACK)
			if player.bombtimer == 0
				player.bombtimer = TICRATE
				player.bomb = P_SPMAngle(player.mo, MT_FBOMB, player.mo.angle, 1)
				if player.bomb and player.bomb.valid
					P_SetObjectMomZ(player.bomb, 15*FRACUNIT)
				end
			end
		end
	end
end)

-- Metal
addHook("PlayerThink", function(player) //lua by ThyEnden709 Edited by BlueTorch
	if player and player.mo and player.mo.valid and player.mo.skin == "metalsonic"
		player.powers[pw_underwater] = 100*TICRATE
		player.powers[pw_spacetime] = 100*TICRATE
		
		if not (player.cmd.buttons & BT_SPIN) then -- Begin new lines
			player.spintapready = true
			player.spintapping = false
		elseif player.spintapready then
			player.spintapping = true
			player.spintapready = false
		else
			player.spintapping = false
		end -- End new lines
		
		if player.metalcooldown == nil
			player.metalcooldown = 0
			player.misslemetal = nil
		end
		
		if player.metalcooldown > 0
			player.metalcooldown = $-1
		end
		
		--lmao
		player.charability2 = CA2_SPINDASH
		if not P_IsObjectOnGround(player.mo)
			player.popguntarget = P_LookForEnemies(player, false, true)
		end
		
		if (player.popguntarget 
		and player.popguntarget.valid 
		and player.popguntarget.health)
				
			player.popgunangle = R_PointToAngle2(player.mo.x, player.mo.y, player.popguntarget.x, player.popguntarget.y)
			if player.metalcooldown == 0
				P_SpawnLockOn(player, player.popguntarget, S_LOCKON1)
			end
		end
		
		if player.misslemetal
		and player.misslemetal.valid
			player.misslemetal.state = S_ENERGYBALL2
		end
		
		if not P_IsObjectOnGround(player.mo)
			if player.spintapping == true
				if player.popguntarget and player.popguntarget.valid
					if player.metalcooldown == 0
						player.misslemetal = P_SpawnMissile(player.mo, player.popguntarget, MT_CLONEMETALBALL)
						player.metalcooldown = TICRATE*6/5
					end
				end
			end
		end
	end
end)